#pragma once


const int xTileSize = 30;
const int yTileSize = 30;

class CTile
{
public:
	CTile( CPoint pos = CPoint(0, 0) );
	~CTile();

	int				GetTileIdx() { return _tileidx; }

	virtual void	DrawDC( CDC* pDC );
	void			AllClearTileIdx();
	virtual CTile*	Pick( CPoint pos );
	virtual CTile*	PickEx( CPoint tileidxpos );

public:
	int		_tileidx;
	CPoint	_pos;
	bool	bSideTile;

	CTile	*TL, *T, *TR, *L, *R, *BL, *B, *BR;
};



class CTileGroup : public CTile
{
public:
	CTileGroup();
	~CTileGroup();

	void			Add( CTile* tile );
	void			AllClearTileIdx();
	virtual void	DrawDC( CDC* pDC );
	virtual CTile*	Pick( CPoint pos );
	virtual CTile*	PickEx( CPoint tileidxpos );

public:
	vector< CTile* >	_components;
};




class CTileMgr
{
	CTileMgr();
public:
	~CTileMgr();
	static CTileMgr& GetInstance()
	{
		static CTileMgr mgr;
		return mgr;
	}

	CTileGroup*		GetRoot() { return _root; }

	void			AllClearTileIdx();
	void			DrawDC( CDC* pDC );
	CTile*			Pick( CPoint pos );
	void			PickEx( CPoint pos );
	void			ChkSide();

private:
	void			tracePick( CPoint tileidxpos, int intilenumber );
	void			traceChkSide( CPoint tileidxpos, int& count);

public:
	CTileGroup*	_root;
};




class CTileFactory
{
	CTileFactory() {}
public:
	static CTileFactory& GetInstance()
	{
		static CTileFactory factory;
		return factory;
	}

	void		CreateTileRoot();
	void		AddRootTile();
	void		CreateNeighborhood();
};
